#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Matrix.cpp"
#define GRIDSIZE 90                                   
#define WINDOWSIZE 90
#define DEL_T 1.0
//GLfloat e=2.0;
//GLfloat d=1.5
float S=0.005;
GLfloat aA1=0.03125;
GLfloat aA2=0.03125;
GLfloat bA= 0.00;

GLfloat aI1=0.125;
GLfloat aI2=0.195;
GLfloat bI= 0.00;

GLfloat k= 0.15;
GLfloat l= 0.1;
//GLfloat F=0.2;
//GLfloat S= 0.0105;
int timer=0;
GLfloat h=1.0;
GLfloat THETA=0.5;
FloatMatrix AA(2,2);
FloatMatrix AI(2,2);


/*GLfloat cA[GRIDSIZE][GRIDSIZE];
GLfloat cI[GRIDSIZE][GRIDSIZE];
GLfloat oldCA[GRIDSIZE][GRIDSIZE];
GLfloat oldCI[GRIDSIZE][GRIDSIZE];*/
GLfloat displayMatrix[GRIDSIZE][GRIDSIZE][3];

FloatMatrix *cA;
FloatMatrix *cI;
FloatMatrix *oldCA;
FloatMatrix *oldCI;
FloatMatrix *BETA;
//FloatMatrix displayMatrix(GRIDSIZE,GRIDSIZE);

FloatMatrix MA(3,3);
FloatMatrix MI(3,3);

GLfloat RA (int i, int j){
	/*if (cA->item[i][j] > cI->item[i][j]){
		//printf("Adding: %f\n",k);
		return k;
	}
	else
		return 0.0;
	//return ((F+k)*cA->item[i][j]);*/
	return (S*(oldCI->item[i][j]*oldCA->item[i][j]-oldCA->item[i][j]-BETA->item[i][j]));
}

GLfloat RI (int i, int j){
	/*//if (i==5 && j==5)
	//	printf("Inhibitor Reaction Function: CA=%f, CI=%f\n",cA->item[i][j],cI->item[i][j]);
	if (cA->item[i][j] > cI->item[i][j]){
	//	if (i==5 && j==5)
	//		printf("Adding: %f\n",l);
		return l;
	}
	else{
	//	if (i==5 && j==5)
	//		printf("Adding: %f\n",0);
		return 0.0;
	}
	//return -1*F*(1.0-cI->item[i][j]);*/
	return (S*(16-oldCI->item[i][j]*oldCA->item[i][j]));
}

void mouse(int button, int state, int y, int x){
	x=GRIDSIZE-x;
	if (button==0){
	//add activator
		cA->item[x-1][y]+=4.0;
		cA->item[x+1][y]+=4.0;
		cA->item[x][y-1]+=4.0;
		cA->item[x][y+1]+=4.0;
	}else if (button==2){
	//add inhibitor
		cI->item[x-1][y]+=4.0;
		cI->item[x+1][y]+=4.0;
		cI->item[x][y-1]+=4.0;
		cI->item[x][y+1]+=4.0;
	}
}
void save()
{
	int i,j;
	for (i=0; i< GRIDSIZE; i++){
		for (j=0; j< GRIDSIZE; j++){
			displayMatrix[i][j][0]=cI->item[i][j]/6.0;
			displayMatrix[i][j][1]=cA->item[i][j]/6.0;
			displayMatrix[i][j][2]=0.0;
		}
	}
	oldCA->copyFrom(cA);
	oldCI->copyFrom(cI);
			
}

void changeImage()
{
	int i,j,k;
	
	
	FloatMatrix *tempA=convolve(&MA,oldCA);
	FloatMatrix *tempI=convolve(&MI,oldCI);
	
	/** Now apply the reaction function and DEL_T (TimeStep) */
	for (i=1;i<GRIDSIZE-1;i++){
		for (j=0;j<GRIDSIZE;j++){
						
			cA->item[i][j]+= DEL_T * (tempA->item[i][j]+RA(i,j));
			cI->item[i][j]+= DEL_T * (tempI->item[i][j]+RI(i,j));
			//glColor3f(cI->item[i][j],0.0,cA->item[i][j]);
			if (cA->item[i][j]<0.0)
				cA->item[i][j]=0.0;
			if (cI->item[i][j]<0.0)
				cI->item[i][j]=0.0;
			
		}
	}
	//printf("cA[5][5]=%f\n",cA->item[5][5]);
	//printf("cI[5][5]=%f\n",cI->item[5][5]);
}


/** 
	Set all concentrations for both chemicals to 4
*/
void myinit()
{
	//*************************  Do initial concentrations **********************************
	int i,j;
	GLfloat color=0.0;
	glShadeModel(GL_FLAT);
		
	glClearColor(0.0,0.0,0.0,0.0); /* Black Background */
	glColor3f(1.0, 1.0, 1.0);
	glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

	cA=new FloatMatrix(WINDOWSIZE,WINDOWSIZE);
	cI=new FloatMatrix(WINDOWSIZE,WINDOWSIZE);
	oldCA=new FloatMatrix(WINDOWSIZE,WINDOWSIZE);
	oldCI=new FloatMatrix(WINDOWSIZE,WINDOWSIZE);
	BETA=new FloatMatrix(WINDOWSIZE,WINDOWSIZE);	
	for (i=0;i<GRIDSIZE;i++)
	{		
		for (j=0;j<GRIDSIZE;j++){
			color=4.0;//(3.0*rand()/(RAND_MAX))-1.0; //random no. between 0.0 and 1.0
			cA->item[i][j]=color;
			color=4.0;//(3.0*rand()/(RAND_MAX))-1.0; //random no. between 0.0 and 1.0
			cI->item[i][j]=color;
			color=(0.1*rand()/(RAND_MAX+1.0))+11.95; //random no. between 11.95 and 12.05
			BETA->item[i][j]=color;
			
		}
	
	}
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	save(); //save concentrations
	//do 'A' matrix
	/*AA.item[0][0]=aA1*aA1*cos(THETA)*cos(THETA) + aA2*aA2*sin(THETA)*sin(THETA);
	AA.item[0][1]=(aA2*aA2 - aA1*aA1)*cos(THETA)*sin(THETA);
	AA.item[1][0]=(aA2*aA2 - aA1*aA1)*cos(THETA)*sin(THETA);
	AA.item[1][1]=aA2*aA2*cos(THETA)*cos(THETA) + aA1*aA1*sin(THETA)*sin(THETA);


	AI.item[0][0]=aI1*aI1*cos(THETA)*cos(THETA) + aI2*aI2*sin(THETA)*sin(THETA);
	AI.item[0][1]=(aI2*aI2 - aI1*aI1)*cos(THETA)*sin(THETA);
	AI.item[1][0]=(aI2*aI2 - aI1*aI1)*cos(THETA)*sin(THETA);
	AI.item[1][1]=aI2*aI2*cos(THETA)*cos(THETA) + aI1*aI1*sin(THETA)*sin(THETA);

	//************************ Do Mask 'M' for activator *************************************
	MA.item[0][0]=-1.0*AA.item[0][1];
	MA.item[0][1]=2.0*AA.item[1][1];
	MA.item[0][2]=AA.item[0][1];
	MA.item[1][0]=2.0*AA.item[0][0];
	MA.item[1][1]=(-4.0*(AA.item[0][0]+AA.item[1][1]))-(2.0*h*h*bA);
	MA.item[1][2]=2.0*AA.item[0][0];
	MA.item[2][0]=AA.item[0][1];
	MA.item[2][1]=2*AA.item[1][1];
	MA.item[2][2]=-1.0*AA.item[0][1];
	MA.applyWeight(1.0/(2*h*h));
	//************************ Do Mask 'M' for inhibitor *************************************
	MI.item[0][0]=-1.0*AI.item[0][1];
	MI.item[0][1]=2.0*AI.item[1][1];
	MI.item[0][2]=AI.item[0][1];
	MI.item[1][0]=2.0*AI.item[0][0];
	MI.item[1][1]=(-4.0*(AI.item[0][0]+AI.item[1][1]))-(2.0*h*h*bI);
	MI.item[1][2]=2.0*AI.item[0][0];
	MI.item[2][0]=AI.item[0][1];
	MI.item[2][1]=2*AI.item[1][1];
	MI.item[2][2]=-1.0*AI.item[0][1];
	MI.applyWeight(1.0/(2*h*h));*/
	//************************ Do Mask 'M' for activator *************************************
	/*MA.item[0][0]=0.0;
	MA.item[0][1]=1.0;
	MA.item[0][2]=0.0;
	MA.item[1][0]=1.0;
	MA.item[1][1]=(-4.0-(h*h*bA));
	MA.item[1][2]=1.0;
	MA.item[2][0]=0.0;
	MA.item[2][1]=1.0;
	MA.item[2][2]=0.0;
	MA.applyWeight(aA1/(h*h));
	//************************ Do Mask 'M' for inhibitor *************************************
	MI.item[0][0]=0.0;
	MI.item[0][1]=1.0;
	MI.item[0][2]=0.0;
	MI.item[1][0]=1.0;
	MI.item[1][1]=(-4.0-(h*h*bI));
	MI.item[1][2]=1.0;
	MI.item[2][0]=0.0;
	MI.item[2][1]=1.0;
	MI.item[2][2]=0.0;
	MI.applyWeight(aI1/(h*h));*/
	
	//do 'A' matrix
	AA.item[0][0]=aA1*cos(THETA)*cos(THETA) + aA2*sin(THETA)*sin(THETA);
	AA.item[0][1]=(aA2 - aA1)*cos(THETA)*sin(THETA);
	AA.item[1][0]=(aA2 - aA1)*cos(THETA)*sin(THETA);
	AA.item[1][1]=aA2*cos(THETA)*cos(THETA) + aA1*sin(THETA)*sin(THETA);


	AI.item[0][0]=aI1*cos(THETA)*cos(THETA) + aI2*sin(THETA)*sin(THETA);
	AI.item[0][1]=(aI2 - aI1)*cos(THETA)*sin(THETA);
	AI.item[1][0]=(aI2 - aI1)*cos(THETA)*sin(THETA);
	AI.item[1][1]=aI2*cos(THETA)*cos(THETA) + aI1*sin(THETA)*sin(THETA);

	//************************ Do Mask 'M' for activator *************************************
	MA.item[0][0]=-1.0*AA.item[0][1];
	MA.item[0][1]=2.0*AA.item[1][1];
	MA.item[0][2]=AA.item[0][1];
	MA.item[1][0]=2.0*AA.item[0][0];
	MA.item[1][1]=(-4.0-(2.0*h*h*bA))*(AA.item[0][0]+AA.item[1][1]);
	MA.item[1][2]=2.0*AA.item[0][0];
	MA.item[2][0]=AA.item[0][1];
	MA.item[2][1]=2*AA.item[1][1];
	MA.item[2][2]=-1.0*AA.item[0][1];
	MA.applyWeight(1.0/(2*h*h));
	//************************ Do Mask 'M' for inhibitor *************************************
	MI.item[0][0]=-1.0*AI.item[0][1];
	MI.item[0][1]=2.0*AI.item[1][1];
	MI.item[0][2]=AI.item[0][1];
	MI.item[1][0]=2.0*AI.item[0][0];
	MI.item[1][1]=(-4.0-(2.0*h*h*bI))*(AI.item[0][0]+AI.item[1][1]);
	MI.item[1][2]=2.0*AI.item[0][0];
	MI.item[2][0]=AI.item[0][1];
	MI.item[2][1]=2*AI.item[1][1];
	MI.item[2][2]=-1.0*AI.item[0][1];
	MI.applyWeight(1.0/(2*h*h));
}
   

void display()
{
	
	/*glBegin(GL_POLYGON);
        glVertex2f(-0.5, -0.5);
        glVertex2f(-0.5, 0.5);
        glVertex2f(0.5, 0.5);
        glVertex2f(0.5, -0.5);
    glEnd();*/

	 //int time=0;
	//for (time=0; time<5000;time++)
	//{ 
		glRasterPos2i(-1,-1);
		save();
		
		glDrawPixels(GRIDSIZE,GRIDSIZE, GL_RGB,GL_FLOAT,displayMatrix);		
		
		//if (timer%100 == 0)
		printf("%d\n",timer++);		 

		changeImage();
	/* if (cA[5][5]>4.0)
		exit(1); */
	 //} 

	glFlush();	
	glutPostRedisplay();
}	

int main(int argc, char ** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(WINDOWSIZE,WINDOWSIZE);
	glutInitWindowPosition(0,0);
	glutCreateWindow("test");
	glutMouseFunc(mouse);
	glutDisplayFunc(display);
	myinit();
	glClear(GL_COLOR_BUFFER_BIT);
	glutMainLoop();
}
